package vip.xiaonuo.money.service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import vip.xiaonuo.common.pojo.CommonResult;
import vip.xiaonuo.money.entity.MoneyProduce;
import com.baomidou.mybatisplus.extension.service.IService;
import vip.xiaonuo.money.entity.MoneyProduce0422;
import vip.xiaonuo.money.entity.vo.MoneyProduceScreenVo;
import vip.xiaonuo.money.param.*;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 财务产品销售收入 服务类
 * </p>
 *
 * @author author
 * @since 2024-11-19
 */
public interface IMoneyProduceService extends IService<MoneyProduce> {

    //财务图表收入分析占比
   MoneyProduce analysisIncome(MoneyAnalysisParam analysisParam);

    //财务图表产品销售趋势分析
    JSONArray produceAnalysis(MoneyProduceParam moneyProduceParam);

    //收入分析（国内外）
    JSONObject getInOut(MoneyInOutParam inOutParam);


    //财务图表产品销售收入分析
    JSONArray produceIncomeAnalysis(MoneyProduceIncomeParam moneyProduceParam);

    //大屏各部门销售收入趋势分析
    List<MoneyProduceScreenVo> getList(MoneyInOutParam inOutParam);

    //剔除的关联交易填报
    CommonResult add(MoneyProduceAddParam addParam);

    //剔除的关联交易修改
    CommonResult edit(MoneyProduceEditParam editParam);

    CommonResult delete(Map<String,String> paramsMap);

    Page<MoneyProduce0422> page(MoneyInOutPageParam inOutPageParam);

}
